/*

File: SotW.js

Abstract: Largemouth Software's Single of the Week Widget

Version: 1.5 (International)

� Copyright 2006 Largemouth Software, LLC. All rights reserved.

This Software is provided by Largemouth Software on an "AS IS" basis.  LARGEMOUTH SOFTWARE MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE LARGEMOUTH SOFTWARE PRODUCT OR ITS USE AND OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.

IN NO EVENT SHALL LARGEMOUTH SOFTWARE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE LARGEMOUTH SOFTWARE PRODUCT, HOWEVER CAUSED AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN IF LARGEMOUTH SOFTWARE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

var glassDoneButton;
var whiteInfoButton;
var isIE = false;
var req;
var xmlUrl;
var linkUrl;
var imageUrl;

function loadXMLDoc(url) {	
	if (window.ActiveXObject) {
		isIE = true;
		req = new ActiveXObject("Microsoft.XMLHTTP");
		if (req) {
			req.onreadystatechange = processReqChange;
			req.open("GET", url, false);
			req.send();
		}
	} else {
	// branch for native XMLHttpRequest object
		req = new XMLHttpRequest();
		req.onreadystatechange = processReqChange;
		req.open("GET", url, true);
		req.send(null);
	} 
}

function getElementTextNS(prefix, local, parentElem, index) 
{
    var result = "";
    if (prefix && isIE) {
        result = parentElem.getElementsByTagName(prefix + ":" + local)[index];
    } else {
        result = parentElem.getElementsByTagName(local)[index];
    }
    if (result) {
		return result.firstChild.nodeValue;    		
    } else {
        alert("Couldn't update Single of the Week.");
        linkUrl = 'http://click.linksynergy.com/fs-bin/click?id=uD0pi4Lemno&offerid=78941.10000945&type=4&subid=0';
		imageUrl = "http://images.apple.com/itunesaffiliates/US/SOTW/SOTW_120x90.jpg";
    }
}

function decodeXml() 
{
	var items = req.responseXML.getElementsByTagName("item");
	imageUrl = getElementTextNS("", "image", items[0], 0);
	linkUrl = getElementTextNS("", "link", items[0], 0);
	updateImage();
}

function processReqChange() 
{
	if (req.readyState == 4)
	{
		if (req.status == 200)
		{
			decodeXml();
		} else if (req.status) {
			alert("Couldn't update Single of the Week.\n\nXML retrieve error status:\n" + req.statusText);
		}		
		decodeXml();
	}
}

function setup()
{
	glassDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
	whiteInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs);
	
	
	if (window.widget)		// always check to make sure that you are running in Dashboard
	{
		widget.onshow = update;
	
		// Load the preferences...
		var countryString = widget.preferenceForKey("countryString");

		if (countryString && countryString.length > 0)  // if the retrieved preferences are not empty,
		{											    // they are restored.
			if ( countryString == "United States" )	
			{
				document.getElementById("countryPopup").selectedIndex = 0;
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_usa.xml";
				update();
			}
			else if ( countryString == "Australia" )
			{
				document.getElementById("countryPopup").selectedIndex = 1;
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_aus.xml";
				update();
			}
			else if ( countryString == "Canada" )
			{
				document.getElementById("countryPopup").selectedIndex = 2;
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_can.xml";
				update();
			}
			else if ( countryString == "France" )
			{
				document.getElementById("countryPopup").selectedIndex = 3;
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_fra.xml";
				update();
			}
			else if ( countryString == "Japan" )
			{
				document.getElementById("countryPopup").selectedIndex = 4;
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_nip.xml";
				update();
			}
			else if ( countryString == "United Kingdom" )
			{
				document.getElementById("countryPopup").selectedIndex = 5;
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_uk.xml";
				update();
			}
		} else {
			//We need to store a new preference, using USA as the default...
			widget.setPreferenceForKey("United States","countryString");
			xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_usa.xml";
			update();
		}
	}
}


function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	
}


function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}

function changeCountry(elem)
{	
	var clickText = document.getElementById("lmsText");
	
	switch( elem.selectedIndex )					// find out which option was chosen
	{
		case 0:
			if(window.widget)
			{
				widget.setPreferenceForKey("United States","countryString");	// and save the new preference to disk
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_usa.xml";
				clickText.innerHTML = "Click image for the";
				update();
			}
			break;
		case 1:										
			if(window.widget)
			{
				widget.setPreferenceForKey("Australia","countryString");	// and save the new preference to disk
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_aus.xml";
				clickText.innerHTML = "Click image for the";
				update();
			}
			break;
		case 2:										
			if(window.widget)
			{
				widget.setPreferenceForKey("Canada","countryString");	// and save the new preference to disk
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_can.xml";
				clickText.innerHTML = "Click image for the";
				update();
			}
			break;
		case 3:										
			if(window.widget)
			{
				widget.setPreferenceForKey("France","countryString");	// and save the new preference to disk
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_fra.xml";
				clickText.innerHTML = "Image de clic pour";
				update();
			}
			break;
		case 4:										
			if(window.widget)
			{
				widget.setPreferenceForKey("Japan","countryString");	// and save the new preference to disk
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_nip.xml";
				clickText.innerHTML = "かちりと言う音";
				update();
			}
			break;
		case 5:										
			if(window.widget)
			{
				widget.setPreferenceForKey("United Kingdom","countryString");	// and save the new preference to disk
				xmlUrl = "http://www.largemouthsoftware.com/sotw/sotw_uk.xml";
				clickText.innerHTML = "Click image for the";
				update();
			}
			break;
	}
} 

function clicked(area)
{
	if (widget)
	{
	   if (area == 'song')
	   {
	   		widget.openURL(linkUrl);
	   }
	   else if (area == 'lms')
	   {
			widget.openURL('http://www.largemouthsoftware.com/sotw.html');
	   }
	}
}

function update ()
{
	if (xmlUrl == "")
	{
		updateImage();
		return;
	}
	var now = new Date();
    loadXMLDoc(xmlUrl + "?" + now.getTime());
}


function updateImage ()
{ 	
	var imageSpan = document.getElementById("sotw_image");
	var now = new Date();
	
	if (widget)
	{		
		if (imageSpan) {
			imageSpan.innerHTML = "<img width=\"120\" src=\"" + imageUrl + "?" + now.getTime() + "\">"; 
		}
	}
}